
-- --------------------------------------------------
-- Entity Designer DDL Script for SQL Server 2005, 2008, and Azure
-- --------------------------------------------------
-- Date Created: 10/07/2010 14:35:28
-- Generated from EDMX file: C:\src\SIG\2010-10 - EF_WPF\PhotoTagger\PhotoTagger.Repository\PhotoModel.edmx
-- --------------------------------------------------

SET QUOTED_IDENTIFIER OFF;
GO
USE [PhotoTaggerDb];
GO
IF SCHEMA_ID(N'dbo') IS NULL EXECUTE(N'CREATE SCHEMA [dbo]');
GO

-- --------------------------------------------------
-- Dropping existing FOREIGN KEY constraints
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[FK_PhotoCategory_Photo]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[PhotoCategory] DROP CONSTRAINT [FK_PhotoCategory_Photo];
GO
IF OBJECT_ID(N'[dbo].[FK_PhotoCategory_Category]', 'F') IS NOT NULL
    ALTER TABLE [dbo].[PhotoCategory] DROP CONSTRAINT [FK_PhotoCategory_Category];
GO

-- --------------------------------------------------
-- Dropping existing tables
-- --------------------------------------------------

IF OBJECT_ID(N'[dbo].[Photos]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Photos];
GO
IF OBJECT_ID(N'[dbo].[Categories]', 'U') IS NOT NULL
    DROP TABLE [dbo].[Categories];
GO
IF OBJECT_ID(N'[dbo].[PhotoCategory]', 'U') IS NOT NULL
    DROP TABLE [dbo].[PhotoCategory];
GO

-- --------------------------------------------------
-- Creating all tables
-- --------------------------------------------------

-- Creating table 'Photos'
CREATE TABLE [dbo].[Photos] (
    [PhotoId] uniqueidentifier  NOT NULL,
    [Path] nvarchar(max)  NOT NULL,
    [Title] nvarchar(max)  NULL,
    [Location] nvarchar(max)  NULL,
    [Description] nvarchar(max)  NULL,
    [Rating] tinyint  NULL,
    [ModifiedDate] datetime  NULL,
    [CatalogCatalogId] uniqueidentifier  NOT NULL
);
GO

-- Creating table 'Categories'
CREATE TABLE [dbo].[Categories] (
    [CategoryId] uniqueidentifier  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'Catalogs'
CREATE TABLE [dbo].[Catalogs] (
    [CatalogId] uniqueidentifier  NOT NULL,
    [Name] nvarchar(max)  NOT NULL
);
GO

-- Creating table 'PhotoCategory'
CREATE TABLE [dbo].[PhotoCategory] (
    [Photos_PhotoId] uniqueidentifier  NOT NULL,
    [Categories_CategoryId] uniqueidentifier  NOT NULL
);
GO

-- --------------------------------------------------
-- Creating all PRIMARY KEY constraints
-- --------------------------------------------------

-- Creating primary key on [PhotoId] in table 'Photos'
ALTER TABLE [dbo].[Photos]
ADD CONSTRAINT [PK_Photos]
    PRIMARY KEY CLUSTERED ([PhotoId] ASC);
GO

-- Creating primary key on [CategoryId] in table 'Categories'
ALTER TABLE [dbo].[Categories]
ADD CONSTRAINT [PK_Categories]
    PRIMARY KEY CLUSTERED ([CategoryId] ASC);
GO

-- Creating primary key on [CatalogId] in table 'Catalogs'
ALTER TABLE [dbo].[Catalogs]
ADD CONSTRAINT [PK_Catalogs]
    PRIMARY KEY CLUSTERED ([CatalogId] ASC);
GO

-- Creating primary key on [Photos_PhotoId], [Categories_CategoryId] in table 'PhotoCategory'
ALTER TABLE [dbo].[PhotoCategory]
ADD CONSTRAINT [PK_PhotoCategory]
    PRIMARY KEY NONCLUSTERED ([Photos_PhotoId], [Categories_CategoryId] ASC);
GO

-- --------------------------------------------------
-- Creating all FOREIGN KEY constraints
-- --------------------------------------------------

-- Creating foreign key on [Photos_PhotoId] in table 'PhotoCategory'
ALTER TABLE [dbo].[PhotoCategory]
ADD CONSTRAINT [FK_PhotoCategory_Photo]
    FOREIGN KEY ([Photos_PhotoId])
    REFERENCES [dbo].[Photos]
        ([PhotoId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;
GO

-- Creating foreign key on [Categories_CategoryId] in table 'PhotoCategory'
ALTER TABLE [dbo].[PhotoCategory]
ADD CONSTRAINT [FK_PhotoCategory_Category]
    FOREIGN KEY ([Categories_CategoryId])
    REFERENCES [dbo].[Categories]
        ([CategoryId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_PhotoCategory_Category'
CREATE INDEX [IX_FK_PhotoCategory_Category]
ON [dbo].[PhotoCategory]
    ([Categories_CategoryId]);
GO

-- Creating foreign key on [CatalogCatalogId] in table 'Photos'
ALTER TABLE [dbo].[Photos]
ADD CONSTRAINT [FK_CatalogPhoto]
    FOREIGN KEY ([CatalogCatalogId])
    REFERENCES [dbo].[Catalogs]
        ([CatalogId])
    ON DELETE NO ACTION ON UPDATE NO ACTION;

-- Creating non-clustered index for FOREIGN KEY 'FK_CatalogPhoto'
CREATE INDEX [IX_FK_CatalogPhoto]
ON [dbo].[Photos]
    ([CatalogCatalogId]);
GO

-- --------------------------------------------------
-- Script has ended
-- --------------------------------------------------