﻿using ViewModelLocatorsWithConverters.Model;

namespace ViewModelLocatorsWithConverters.ViewModels
{
    public class PersonViewModel : ViewModelBase
    {

        #region Constructors

        public PersonViewModel(Person model)
        {
            Person = model;

            model.PropertyChanged += Person_PropertyChanged;
        }

        #endregion

        #region Properties

        private Person _Person;
        public Person Person
        {
            get { return _Person; }
            set
            {
                if (value == _Person)
                    return;

                _Person = value;
                OnPropertyChanged("Person");
            }
        }



        public string FormattedName
        {
            get
            {
                if (null == Person)
                    return string.Empty;

                switch (Person.Role)
                {
                    case "Mother":
                    case "Father":
                        return Person.Name.ToUpper();

                    default:
                        return Person.Name;
                }
            }
        }

        #endregion

        #region Internal

        void Person_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            switch (e.PropertyName)
            {
                case "Name":
                    OnPropertyChanged("FormattedName");
                    break;

                default:
                    break;
            }
        }


        #endregion

    }
}
